<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/12/2003 *
 * ===================                          Last change: 12/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_points.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Setup welcome-points for registration etc.       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Einstellen der Willkommensgutschrift usw.        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Init variables
$message = '';

// Is the 'sub' parameter set?
if (isGetRequestParameterSet('sub')) {
	// Yes, then do some sanity-checks
	switch (getRequestParameter('sub')) {
		case 'points':
			if ((!isPostRequestParameterSet(('points_register'))) || (!isPostRequestParameterSet(('points_ref')))) {
				unsetPostRequestParameter('ok');
			}
			break;

		case 'ref':
			if (isGetRequestParameterSet('do')) {
				if (((!isPostRequestParameterSet(('level'))) || (!isPostRequestParameterSet(('percents')))) && (getRequestParameter('do') == 'add')) {
					unsetPostRequestParameter('ok');
				}
			}
			break;
	}
} else {
	// Display overview
	setGetRequestParameter('sub', 'overview');
}

if (isFormSent()) {
	initSqls();
	switch (getRequestParameter('sub')) {
		case 'points':
			updateConfiguration(array('points_register', 'points_ref'), array(postRequestParameter('points_register'), postRequestParameter('points_ref')));
			break;

		case 'ref':
			switch (getRequestParameter('do'))
			{
				case 'add':
					addSql("INSERT INTO `{?_MYSQL_PREFIX?}_refdepths` (`level`, `percents`) VALUES ('".postRequestParameter('level')."','".postRequestParameter('percents')."')");
					break;

				case 'edit': // Change entries
					foreach (postRequestParameter('level') as $id => $value) {
						// Secure id
						$id = bigintval($id);

						// Revert german commata
						setPostRequestParameter('percents', array($id => convertCommaToDot(postRequestParameter('percents', $id))));

						// Update entry
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_refdepths` SET `level`='%s', `percents`='%s' WHERE `id`=%s LIMIT 1",
						array(bigintval($value), postRequestParameter('percents', $id), $id), __FILE__, __LINE__);
					}
					$message = getMessage('REF_DEPTHS_SAVED');
					break;

				case 'del':
					foreach (postRequestParameter('id') as $id => $value) {
						SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_refdepths` WHERE `id`=%s LIMIT 1",
						array(bigintval($id)), __FILE__, __LINE__);
					}
					$message = getMessage('REF_DEPTHS_DELETED');
					break;
			}

			// Update cache file
			// @TODO Rewrite this to a filter
			if (isExtensionInstalledAndNewer('cache', '0.1.2')) {
				if ($GLOBALS['cache_instance']->loadCacheFile('refdepths')) $GLOBALS['cache_instance']->removeCacheFile();
			} // END - if
			break;

		case 'settings':
			$REF = bigintval(postRequestParameter('ref_payout'));
			updateConfiguration(
				array('allow_direct_pay', 'reg_points_mode', 'ref_payout'),
				array(postRequestParameter('allow_direct_pay'), postRequestParameter('reg_points_mode'), $REF)
			);
			if ((getConfig('ref_payout') == '0') && (postRequestParameter('ref_payout') > 0)) {
				// Update account's ref_payout for "must-confirm"
				addSql(sprintf("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `ref_payout`=(%s - `mails_confirmed`)
WHERE `mails_confirmed` < %s", $REF, $REF));
			} elseif ((getConfig('ref_payout') > 0) && (postRequestParameter('ref_payout') == '0')) {
				// Update account's ref_payout for "not-must-confirm"
				addSql("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `ref_payout`=0 WHERE `ref_payout` > 0");
				addSql("UPDATE `{?_MYSQL_PREFIX?}_user_points` SET `points`=`points`+`locked_points` WHERE `locked_points` > 0");
				addSql("UPDATE `{?_MYSQL_PREFIX?}_user_points` SET `locked_points`=0 WHERE `locked_points` > 0");
			}
			break;
	}

	if ((isSqlsValid()) && (isSqlsValid())) {
		if (strpos($GLOBALS['sqls'][0], 'INSERT') > -1) {
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_refdepths` WHERE `level`='%s' LIMIT 1",
				array(bigintval(postRequestParameter('level'))), __FILE__, __LINE__);
			SQL_FREERESULT($result);
		} // END - if

		if (countSqls() > 0) {
			// Run all SQL commands
			runFilterChain('run_sqls');

			// Entry saved...
			$message = getMessage('SETTINGS_SAVED');

			// Destroy config cache file here...
			rebuildCache('config', 'config');
		} else {
			// Prepare failed-message
			$message = '<span class="admin_failed">{--SETTINGS_NOT_SAVED--}</span>';
		}

		// Remove SQL queries
		unsetSqls();
	}

	// Shall we display a message?
	if (!empty($message)) {
		// When do so...
		loadTemplate('admin_settings_saved', false, $message);
	}
} elseif (getRequestParameter('sub') == 'settings') {
	// Setup some settings like direct pay and so on
	// Including new add-mode for one-time referal bonus
	foreach (array('allow_direct_pay') as $entry) {
		$content[$entry . '_y'] = '';
		$content[$entry . '_n'] = '';
		$content[$entry . '_' . strtolower(getConfig($entry))] = ' checked="checked"';
	} // END - foreach

	// One-time referal bonus add-mode
	foreach (array('reg_points_mode_ref','reg_points_mode_direct') as $entry) {
		$content[$entry] = '';
	} // END - if
	$content['reg_points_mode_' . strtolower(getConfig('reg_points_mode'))] = ' checked="checked"';

	// Load template
	loadTemplate('admin_config_point_settings', false, $content);
} elseif (getRequestParameter('sub') == 'ref') {
	// 12                  3     32    2                  3     32    2               3            4     43    21
	if ((isPostRequestParameterSet('del')) && (isPostRequestParameterSet('sel')) && (countPostSelection() > 0)) {
		// Delete entries
		$OUT = ''; $SW = 2;
		foreach (postRequestParameter('sel') as $id => $value) {
			$result = SQL_QUERY_ESC("SELECT `level`, `percents` FROM `{?_MYSQL_PREFIX?}_refdepths` WHERE `id`=%s LIMIT 1",
				array(bigintval($id)), __FILE__, __LINE__);
			$content = SQL_FETCHARRAY($result);
			SQL_FREERESULT($result);

			// Prepare data for the row template
			$content = array(
				'sw'       => $SW,
				'id'       => $id,
				'level'    => $content['level'],
				'percents' => translateComma($content['percents']),
			);

			// Load row template and switch color
			$OUT .= loadTemplate('admin_points_del_row', true, $content);
			$SW = 3 - $SW;
		}

		// Load main template
		loadTemplate('admin_points_del', false, $OUT);
	} elseif ((isPostRequestParameterSet('edit')) && (isPostRequestParameterSet('sel')) && (countPostSelection() > 0)) {
		// Edit entries
		$OUT = ''; $SW = 2;
		foreach (postRequestParameter('sel') as $id => $value) {
			$result = SQL_QUERY_ESC("SELECT `level`, `percents` FROM `{?_MYSQL_PREFIX?}_refdepths` WHERE `id`=%s LIMIT 1",
				array(bigintval($id)), __FILE__, __LINE__);
			$content = SQL_FETCHARRAY($result);
			SQL_FREERESULT($result);

			// Prepare data for the row template
			$content = array(
				'sw'       => $SW,
				'id'       => $id,
				'level'    => $content['level'],
				'percents' => translateComma($content['percents']),
			);

			// Load row template and switch color
			$OUT .= loadTemplate('admin_points_edit_row', true, $content);
			$SW = 3 - $SW;
		}

		// Load main template
		loadTemplate('admin_points_edit', false, $OUT);
	} else {
		// Referal levels
		$result = SQL_QUERY("SELECT `id`, `level`, `percents` FROM `{?_MYSQL_PREFIX?}_refdepths` ORDER BY `level` ASC", __FILE__, __LINE__);
		if (SQL_NUMROWS($result) > 0) {
			// Make referal levels editable and deletable
			$OUT = ''; $SW = 2;

			// List already existing categories for editing
			while ($content = SQL_FETCHARRAY($result)) {
				// Prepare data for the row template
				$content['sw']       = $SW;
				$content['percents'] = translateComma($content['percents']);

				// Load row template and switch color
				$OUT .= loadTemplate('admin_points_row', true, $content);
				$SW = 3 - $SW;
			}

			// Free memory
			SQL_FREERESULT($result);

			// Load main template
			loadTemplate('admin_points', false, $OUT);
		}

		// Form for adding new referal levels
		loadTemplate('admin_add_reflevel');
	}
} elseif (getRequestParameter('sub') == 'points') {
	// Load template
	loadTemplate('admin_config_sub_points');
} else {
	// Display selection box
	loadTemplate('admin_config_points');
}

// [EOF]
?>
