<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/19/2003 *
 * ===================                          Last change: 12/12/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-payments.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Payments (points) for confirmed mails            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Verguetungen fuer best&auml;tigte Mails              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (((!isPostRequestParameterSet(('t_wait'))) || (!isPostRequestParameterSet(('payment')))) && (isGetRequestParameterSet('do')) && (getRequestParameter('do') == 'add')) {
	unsetPostRequestParameter('ok');
} // END - if

if (isFormSent()) {
	switch (getRequestParameter('do')) {
		case 'add':
			addSql("INSERT INTO `{?_MYSQL_PREFIX?}_payments` (time, payment, mail_title, price) VALUES ('".postRequestParameter('t_wait')."','".postRequestParameter('payment')."','".postRequestParameter('title')."','".postRequestParameter('price')."')");
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_payments` WHERE time='%s' LIMIT 1",
			array(postRequestParameter('t_wait')), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Re-init the array here
				initSqls();

				// Free memory
				SQL_FREERESULT($result);
			}
			break;

		case 'edit':
			foreach (postRequestParameter('time') as $id => $value) {
				addSql("UPDATE `{?_MYSQL_PREFIX?}_payments` SET time='".$value."', payment='".postRequestParameter('pay', $id)."', price='".postRequestParameter('price', $id)."', mail_title='".postRequestParameter('title', $id)."' WHERE `id`='".$id."' LIMIT 1");
			}
			break;

		case 'del':
			foreach (postRequestParameter('id') as $id => $value) {
				addSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_payments` WHERE `id`='".$id."' LIMIT 1");
			}
			break;
	} // END - switch

	// Save settings
	if (countSqls() > 0) {
		// Run all queries
		runFilterChain('run_sqls');
		$content = '<span class="admin_failed">{--SETTINGS_SAVED--}</span>';
	} else {
		// Nothing has changed!
		$content = '<span class="admin_failed">{--SETTINGS_NOT_SAVED--}</span>';
	}

	// Output template
	loadTemplate('admin_settings_saved', false, $content);
} elseif ((isPostRequestParameterSet('del')) && (countPostSelection() > 0)) {
	// Delete entries here
	$OUT = ''; $SW = 2;
	foreach (postRequestParameter('sel') as $id => $value) {
		$result = SQL_QUERY_ESC("SELECT time, mail_title FROM `{?_MYSQL_PREFIX?}_payments` WHERE `id`=%s LIMIT 1",
		array(bigintval($id)), __FILE__, __LINE__);
		list($time, $title) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Prepare array for the row template
		$content = array(
			'sw'    => $SW,
			'id'    => $id,
			'time'  => $time,
			'title' => $title,
		);

		// Load row template and switch colors
		$OUT .= loadTemplate('admin_del_payments_row', true, $content);
		$SW = 3 - $SW;
	}

	// Load main template
	loadTemplate('admin_del_payments', false, $OUT);
} elseif ((isPostRequestParameterSet('edit')) && (countPostSelection() > 0)) {
	// Edit entries
	$OUT = ''; $SW = 2;
	foreach (postRequestParameter('sel') as $id => $value) {
		$result = SQL_QUERY_ESC("SELECT time, payment, mail_title, price FROM `{?_MYSQL_PREFIX?}_payments` WHERE `id`=%s LIMIT 1",
		array(bigintval($id)), __FILE__, __LINE__);
		list($time, $pay, $title, $price) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Prepare array for the row template
		$content = array(
			'sw'    => $SW,
			'id'    => $id,
			'time'  => $time,
			'title' => $title,
			'pay'   => $pay,
			'price' => $price,
		);

		// Load row template and switch colors
		$OUT .= loadTemplate('admin_edit_payments_row', true, $content);
		$SW = 3 - $SW;
	}

	// Load main template
	loadTemplate('admin_edit_payments', false, $OUT);
} else {
	// Referal levels
	$result = SQL_QUERY("SELECT `id`, `time`, `payment`, `mail_title`, `price` FROM `{?_MYSQL_PREFIX?}_payments` ORDER BY `time` ASC", __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// Make referal levels editable and deletable
		$OUT = ''; $SW = 2;

		// List already existing categories for editing
		while ($content = SQL_FETCHARRAY($result)) {
			// Prepare array for the row template
			// @TODO Rewritings: title->mail_title, pay->payment in template
			$content = array(
				'sw'    => $SW,
				'id'    => $content['id'],
				'time'  => $content['time'],
				'title' => $content['mail_title'],
				'pay'   => translateComma($content['payment']),
				'price' => translateComma($content['price'])
			);

			// Load row template and switch colors
			$OUT .= loadTemplate('admin_payments_list_row', true, $content);
			$SW = 3 - $SW;
		} // END - switch

		// Free memory
		SQL_FREERESULT($result);

		// Load main template
		loadTemplate('admin_list_payments', false, $OUT);
	} // END - if

	// Form for adding new referal levels
	loadTemplate('admin_add_payment');
}

// [EOF]
?>
